subroutine instst

use params
use mini
implicit none
external residss

!variables to compute asset and labor earnings distribution
integer :: cnt1, cnt2, ucnt2, check(nl), tempcnt(nl)
double precision, allocatable :: temp1(:,:), temp2(:,:), temp3(:,:)
double precision, allocatable :: adist(:,:), lidist(:,:)

double precision :: perc20, perc40, perc60, perc80


economyss(:)=economy_t(:,1)
Nuss=Nu(1:ne,1:nh,1:J,1)
bss(:)=b(:,1)
taukss=tauk(1)
taulss=taul(1)
gconss=gcon(1)

    !Medicare coverage
    cov_mss=cov_m(1)
    !Medicaid coverage
    cov_mdss=cov_md(1,:)

ycatss=ycat(1)
kcatss=kcat(1)
ymnss=ymn(1)
kmnss=kmn(1)

    conditionss=condition(1)
min_penss=min_pen(1) 
pen_ratess=pen_rate(1)
file_minss=file_min(1)
min_prss=min_pr(1)

ACAsubss=ACAsub(1)
allbuyss=allbuy(1)

put_e=put_e_t(:,1)
psi=psi_t(:,:,:,1)

!initial guesses
open (unit=1,file='input_instst_guess.txt')
read(1,*)rss,Nss,Trss,ghexpss,taufss
close(1)

    !Not allowed to condition insurance on health state
    if ( conditionss .eq. 0 ) then
    
    pr_gss=0
    
        do ec=1,ne
        do tc=1,J-1
            do hc=1,nh
                if ( tc .lt. jr-1 ) then
                pr_gss(ec,1,tc)=pr_gss(ec,1,tc)+psi(ec,hc,tc)*Nuss(ec,hc,tc)*cov_p(hc)*sum(pi_h(ec,tc,1:nh,hc)*e_h(1:nh,tc+1))    
                else
                pr_gss(ec,1,tc)=pr_gss(ec,1,tc)+psi(ec,hc,tc)*Nuss(ec,hc,tc)*cov_p(hc)*(1-cov_mss)*sum(pi_h(ec,tc,1:nh,hc)*e_h(1:nh,tc+1)) 
                end if                    
            end do
        pr_gss(ec,1,tc)=pr_gss(ec,1,tc)/((1+rss)*sum(Nuss(ec,:,tc)))
        pr_gss(ec,2:nh,tc)=pr_gss(ec,1,tc)
        end do
        end do
        
        open (unit=1,file='input_instst_insurance_price_guess.txt')
            do tc=1,J
            read(1,*)pr_gss(1,:,tc),pr_gss(2,:,tc)
            end do
        close(1)
                
    end if
    
!rss=7.50114041676393228E-002
!Nss=9.7075810294539870
!Trss=2.51939517347317121E-002
!ghexpss=1.6898642482799264
!taufss=6.13317754783164054E-002

! Call the Function that solves for steady state equilibrium r,N
    call Newton1ss(residss,rss,Nss)
    
     

! Check Market Clearing in goods market
Kss=(((alpha*theta)/(rss+delta))**(1./(1-alpha)))*Nss
Yss=theta*(Kss**alpha)*(Nss**(1-alpha))
exdemss=Css+(nn+delta)*Kss+Hss-Yss

! Compute Dispersion of Wealth and Income
    call Variance(coevarl(1),coevarw(1))

    if ( rank .eq. 0 ) then

        open (unit=1,file='input_instst_guess.txt')
        write(1,*)rss,Nss,Trss,ghexpss,taufss
        close(1)
		
        open (unit=1,file='input_instst_insurance_price_guess.txt')
            do tc=1,J
            write(1,*)pr_gss(1,:,tc),pr_gss(2,:,tc)
            end do
        close(1)
		
    print*,'excess demand in goods market ', exdemss
!    print*,'Kss, Nss, Hss, Css, Yss ',Kss,Nss,Hss,Css,Yss
!    print*,'rss, Nss, Trss, ghexpss, taufss ',rss, Nss, Trss, ghexpss, taufss

    !initian steadystate results
	open (unit=1,file='output_instst_aggregates.txt')
        write(1,*)'economy ','initial '
        write(1,*)'b_nc ',b(1,1)
        write(1,*)'b_c ',b(2,1)
        write(1,*)'r ',r(1)
        write(1,*)'w ',w(1)
        write(1,*)'tau_l ',taup(1)
        write(1,*)'pi_bar ',tauf(1)
        write(1,*)'lbar ',hour(1)
        write(1,*)'K/Y ',K(1)/Y(1)
        write(1,*)'y ',Y(1)/(Sum(Nuss))
        write(1,*)'N ',N(1)
        write(1,*)'Tr ',Tr(1)
        write(1,*)'K ',K(1)
        write(1,*)'exdem ',exdem(1)
        write(1,*)'coefficient_of_var_lab_income ',coevarl(1)
        write(1,*)'coefficient_of_var_wealth ',coevarw(1)
        write(1,*)'pop ',sum(nu(:,:,:,1))
        close(1)

    !age profile
        open (unit=1,file='output_instst_age_profile.txt')
        write(1,*)'age lbar ap c pop c+h sav labinc a trans both cat MN '
            do tc=1,J
            write(1,'(I2,300F12.5)')tc+19,labarssbyage(tc),savingsbyage(tc),consbyage(tc),sum(Nuss(:,:,tc)),&
            cons1byage(tc), savings1byage(tc), labincbyage(tc), savings2byage(tc),nettransfersbyage(tc),medicaidtypebyagess(:,tc)
            end do
        close(1)

        open (unit=1,file='output_instst_insurance_prices.txt')
        write(1,*)'age nc1 nc2 nc3 nc4 nc5 nc6 c1 c2 c3 c4 c5 c6 '
            do tc=1,J
            write(1,'(I2,300F12.5)')tc+19,pr_gss(1,:,tc),pr_gss(2,:,tc)
            end do
        close(1)
        
    

    end if

r(1)=rss
w(1)=wss
K(1)=Kss
K(2)=Kss
N(1)=Nss
Y(1)=Yss
    C(1)=Css
H(1)=Hss
Tr(1)=Trss
taup(1)=taupss
ghexp(1)=ghexpss
tauf(1)=taufss
pr_g(:,:,:,1)=pr_gss

!used in house.f90
Phiss1=Phiss
g_dgss1=g_dgss

!kept just in case
afunss1=afunss
cfunss1=cfunss
lfunss1=lfunss
medicaidexpfunss1=medicaidexpfunss
g_dfss1=g_dfss

!for voting.f90 and welfare.f90
V1=Vss
Phissage1=Phissage
Phissadjusted1=Phissadjusted
g_dmss1=g_dmss
Vborn(:,:,:,:,1)=Vss(:,:,:,:,1,1)


ADis(1:na,1)=ADisss
ADis(1:na,2)=ADisss	

hour(1)=hourss
tauk(1)=taukss
taul(1)=taulss

SS(:,1)=SSss(:)
As(1)=Asss
As(2)=Asss

exdem(1)=exdemss

safety(1)=safetyss
safetycnt(1)=safetycntss

!compute insurance distribution by expense
    call insexpdist (insexp(1:6),insexpage(:,1:6),insexpedu(:,1:6),insexpasset(:,1:6),insexphealth(:,1:6),insexpprod(:,1:6))

!compute insurance distribution by headcount
ins=0
insage=0
insedu=0
insasset=0
inshealth=0
insprod=0

    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    do gc=1,ng
    do sc=1,ns
    do ac=1,na
						
        if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then
        ins(1)=ins(1)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,1)=insage(tc,1)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,1)=insedu(ec,1)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,1)=insasset(ac,1)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,1)=inshealth(hc,1)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,1)=insprod(sc,1)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 2 ) then
        ins(2)=ins(2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,2)=insage(tc,2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,2)=insedu(ec,2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,2)=insasset(ac,2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,2)=inshealth(hc,2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,2)=insprod(sc,2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 3 ) then
        ins(3)=ins(3)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,3)=insage(tc,3)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,3)=insedu(ec,3)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,3)=insasset(ac,3)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,3)=inshealth(hc,3)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,3)=insprod(sc,3)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 4 ) then
        ins(4)=ins(4)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,4)=insage(tc,4)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,4)=insedu(ec,4)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,4)=insasset(ac,4)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,4)=inshealth(hc,4)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,4)=insprod(sc,4)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 5 ) then
        ins(5)=ins(5)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,5)=insage(tc,5)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,5)=insedu(ec,5)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,5)=insasset(ac,5)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,5)=inshealth(hc,5)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,5)=insprod(sc,5)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)

        else if ( hifunss(gc,ec,hc,sc,ac,tc) .eq. 6 ) then
        ins(6)=ins(6)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insage(tc,6)=insage(tc,6)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insedu(ec,6)=insedu(ec,6)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insasset(ac,6)=insasset(ac,6)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        inshealth(hc,6)=inshealth(hc,6)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
        insprod(sc,6)=insprod(sc,6)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)	
        end if

    end do
    end do
    end do
    end do
    end do
    end do
				
pvtinsuredss=ins(1)
selfinsuredss=ins(2)
employerss=ins(3)
medicaress=ins(4)
foodstampss=ins(5)
medicaidss=ins(6)	

pvtinsured(1)=pvtinsuredss
selfinsured(1)=selfinsuredss
employer(1)=employerss
medicare(1)=medicaress
foodstamp(1)=foodstampss
medicaid(1)=medicaidss

hifunss1=hifunss

!Numbers from Castaneda, Diaz-Gimenez, and Rios-Rull, (2003), Accounting for the U.S. earnings and wealth inequality
quintassets(1,1)=-0.39/100
quintassets(1,2)=1.74/100
quintassets(1,3)=5.72/100
quintassets(1,4)=13.43/100
quintassets(1,5)=79.49/100

quintlabearnings(1,1)=-0.4/100
quintlabearnings(1,2)=3.19/100
quintlabearnings(1,3)=12.49/100
quintlabearnings(1,4)=23.33/100
quintlabearnings(1,5)=61.39/100

topassets(1,1)=12.62/100
topassets(1,2)=23.95/100
topassets(1,3)=29.55/100
	
toplabearnings(1,1)=12.38/100
toplabearnings(1,2)=16.37/100
toplabearnings(1,3)=14.76/100

ginicoefassets(1)=0.78
ginicoeflabearnings(1)=0.63

!These are from Kuhn and Rios-Rull (2013)? Need to check
    cvlabearnings(1)=3
    vloglabearnings(1)=1.5

pb80(1)=0.93975
pt99(1)=0.582

    if ( computeasset .eq. 1 ) then

    cnt1=0

        do ac=1,na
            if ( sum(phissadjusted(:,:,:,:,ac,:)) .gt. zero ) then
            cnt1=cnt1+1
            end if
        end do	
	
        allocate (temp1(cnt1,2))
 
        cnt1=0
        temp1=0
            do ac=1,na
                if ( sum(phissadjusted(:,:,:,:,ac,:)) .gt. zero ) then
                cnt1=cnt1+1
                temp1(cnt1,1)=grida(ac)+Trss
                    do ec=1,ne
                    do hc=1,nh
                    do tc=1,J
                    temp1(cnt1,2)=temp1(cnt1,2)+sum(phissadjusted(:,ec,hc,:,ac,tc))*nuss(ec,hc,tc)/sum(nuss)
                    end do
                    end do
                    end do	
                end if
            end do

            
            call percentile(.2d0,cnt1,temp1,perc20)
            call percentile(.4d0,cnt1,temp1,perc40)
            call percentile(.6d0,cnt1,temp1,perc60)
            call percentile(.8d0,cnt1,temp1,perc80)
          
        quintassetdist=0
            
            do tc=1,J
            do ec=1,ne
            do sc=1,ns
            do hc=1,nh
            do gc=1,ng
            do ac=1,na	
            
                if ( grida(ac)+Trss .lt. perc20 ) then
                quintassetdist(gc,ec,hc,sc,ac,tc)=1
                else if ( grida(ac)+Trss .ge. perc20 .and. grida(ac)+Trss .lt. perc40 ) then
                quintassetdist(gc,ec,hc,sc,ac,tc)=2
                else if ( grida(ac)+Trss .ge. perc40 .and. grida(ac)+Trss .lt. perc60 ) then
                quintassetdist(gc,ec,hc,sc,ac,tc)=3                
                else if ( grida(ac)+Trss .ge. perc60 .and. grida(ac)+Trss .lt. perc80 ) then
                quintassetdist(gc,ec,hc,sc,ac,tc)=4                
                else if ( grida(ac)+Trss .ge. perc80 ) then
                quintassetdist(gc,ec,hc,sc,ac,tc)=5                
                end if
                
                if ( quintassetdist(gc,ec,hc,sc,ac,tc) .eq. 0 .and. rank .eq. 0 ) then
                print*,'quintassetdist(gc,ec,hc,sc,ac,tc) .eq. 0 instst.f90 '
                    call exit
                end if
                
            end do
            end do
            end do
            end do
            end do
            end do
            
            !assets
            allocate(adist(cnt1+1,2))
            adist=zero
            call lorenz(temp1,cnt1,adist(2:cnt1+1,:),cnt1,ginicoefassets(2),cvassets(2),&
            vlogassets(2),avgassets(2),medianassets(2))
            call ineqmoments(adist,cnt1+1,quintassets(2,:),topassets(2,:))
            deallocate(temp1,adist)

            if ( rank .eq. 0 ) then
            print*,'Computed Wealth Distribution at instst.f90 '
            end if

	end if

	cnt2=0
	cnt2=cnt2+1

	do tc=1,J
	do ec=1,ne
	do sc=1,ns
	do hc=1,nh
	check=0
	
            do gc=1,ng
            do ac=1,na	

                do il=1,nl
                    if ( phissadjusted(gc,ec,hc,sc,ac,tc) .gt. zero .and. &
                    lfunss(gc,ec,hc,sc,ac,tc) .eq. gridl(il) .and. check(il) .eq. 0 ) then
                    check(il)=1
                    cnt2=cnt2+1
                    end if
                end do

            end do
            end do
            
        end do
	end do
	end do
	end do

!	cnt2=cnt2+ne
	
	allocate (temp2(cnt2,2))
		
	cnt2=0
	cnt2=cnt2+1
	temp2=0

            do tc=1,J
            do ec=1,ne
            do sc=1,ns
            do hc=1,nh
            check=0
                do gc=1,ng
                do ac=1,na	

                    if ( phissadjusted(gc,ec,hc,sc,ac,tc) .gt. zero ) then 

                        do il=1,nl
                            if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. gridl(il) .and. check(il) .eq. 0 ) then                            
                            check(il)=1
                            cnt2=cnt2+1
!                                if ( tc .le. jr-1 ) then
                                temp2(cnt2,1)=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)
!                                else
!                                temp2(cnt2,1)=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)+SSss(ec)
!                                end if                                
                            temp2(cnt2,2)=phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
                            tempcnt(il)=cnt2

                            else if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. gridl(il) .and. check(il) .eq. 1 ) then
                            temp2(tempcnt(il),2)=temp2(tempcnt(il),2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
                            end if
                        end do

!                        if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. zero .and. tc .le. jr-1 ) then
                        if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. zero ) then                        
                        temp2(1,2)=temp2(1,2)+phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)/sum(nuss)
                        end if

                    end if
	
                end do
                end do
            end do
            end do
            end do
            end do

!             do ec=1,ne
!             cnt2=cnt2+1
!             temp2(cnt2,1)=SSss(ec)
!                 do hc=1,nh
!                 do tc=jr,J
!                 
!                     if ( lfunss(gc,ec,hc,sc,ac,tc) .eq. zero ) then                
!                     temp2(cnt2,2)=temp2(cnt2,2)+sum(phissadjusted(:,ec,hc,:,:,tc))*nuss(ec,hc,tc)/sum(nuss)
!                     end if
!                     
!                 end do
!                 end do
!             end do

            !labor earnings
		
            call sort(temp2,cnt2)
            call percentile(.2d0,cnt2,temp2,perc20)
            call percentile(.4d0,cnt2,temp2,perc40)
            call percentile(.6d0,cnt2,temp2,perc60)
            call percentile(.8d0,cnt2,temp2,perc80)
          
        quintlabearningsdist=0
            
            do tc=1,J
            do ec=1,ne
            do sc=1,ns
            do hc=1,nh
            do gc=1,ng
            do ac=1,na	
            
                if ( wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc) .lt. perc20 ) then
                quintlabearningsdist(gc,ec,hc,sc,ac,tc)=1
                else if ( wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc) .ge. perc20 .and. wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc) .lt. perc40 ) then
                quintlabearningsdist(gc,ec,hc,sc,ac,tc)=2
                else if ( wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc) .ge. perc40 .and. wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc) .lt. perc60 ) then
                quintlabearningsdist(gc,ec,hc,sc,ac,tc)=3                
                else if ( wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc) .ge. perc60 .and. wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc) .lt. perc80 ) then
                quintlabearningsdist(gc,ec,hc,sc,ac,tc)=4                
                else if ( wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc) .ge. perc80 ) then
                quintlabearningsdist(gc,ec,hc,sc,ac,tc)=5                
                end if
                
                if ( quintlabearningsdist(gc,ec,hc,sc,ac,tc) .eq. 0 .and. rank .eq. 0 ) then
                print*,'quintlabearningsdist(gc,ec,hc,sc,ac,tc) .eq. 0 instst.f90 '
                    call exit
                end if
                
            end do
            end do
            end do
            end do
            end do
            end do
                
            call unique(temp2,cnt2,ucnt2)
		
            allocate(lidist(ucnt2+1,2))
            lidist=zero
            call lorenz(temp2,cnt2,lidist(2:ucnt2+1,:),ucnt2,ginicoeflabearnings(2),cvlabearnings(2),&
            vloglabearnings(2),avglabearnings(2),medianlabearnings(2))
            
            call persistence (zero,.8d0,phisstrue,pb80(2),temp2,cnt2,ucnt2)
            call persistence (.99d0,one,phisstrue,pt99(2),temp2,cnt2,ucnt2)
            call ineqmoments(lidist,ucnt2+1,quintlabearnings(2,:),toplabearnings(2,:))

	deallocate(temp2,lidist)

        if ( rank .eq. 0 ) then

            open(unit=1,file='output_instst_inequality_table.txt')
            write(1,*)'1 2 3 4 5 90-95 95-99 99-100 gini'
            write(1,*)'assets'
            write(1,'(300F12.5)')100*quintassets(1,:),100*topassets(1,:),ginicoefassets(1)
            write(1,'(300F12.5)')100*quintassets(2,:),100*topassets(2,:),ginicoefassets(2)
            write(1,*)'labor_earnings'
            write(1,'(300F12.5)')100*quintlabearnings(1,:),100*toplabearnings(1,:),ginicoeflabearnings(1)
            write(1,'(300F12.5)')100*quintlabearnings(2,:),100*toplabearnings(2,:),ginicoeflabearnings(2)
            close(1)
                    
            print*,'Computed wealth and labor earnings distribution at instst.f90 '
            
        end if


        

end subroutine instst
