! This is a subroutine to compute the transition path

subroutine transition

use params
use mini
implicit none

integer :: t ,i , maxit=100
double precision :: Asdev, Ladev, Trdev, ghexpdev, taufdev, insdev
double precision, parameter :: tol=1e-2/2, weight=.75, weight_p=.8
double precision :: dtran

! Guess Initial Prices (note that r(2) is pinned down once N(2) is known
N(2)=N(1)
r(2)=alpha*theta*(N(2)/K(2))**(1.0-alpha)-delta
Tr(2)=Tr(1)
ghexp(2)=ghexp(1)
tauf(2)=tauf(1)

    !initial guesses
   do t=2,time-1
   r(t)=r(t-1)*.5+r(time)*.5
   N(t)=N(t-1)*.5+N(time)*.5
   Tr(t)=Tr(t-1)*.5+Tr(time)*.5
   ghexp(t)=ghexp(t-1)*.5+ghexp(time)*.5
   tauf(t)=tauf(t-1)*.5+tauf(time)*.5	
   end do
	
!	do t=3,time-1
!	r(t)=r(1)*(time-t-1)/(time-4)+r(time)*(t-3)/(time-4)
!	N(t)=N(1)*(time-t-1)/(time-4)+N(time)*(t-3)/(time-4)
!	Tr(t)=Tr(1)*(time-t-1)/(time-4)+Tr(time)*(t-3)/(time-4)
!	ghexp(t)=ghexp(1)*(time-t-1)/(time-4)+ghexp(time)*(t-3)/(time-4)
!	tauf(t)=tauf(1)*(time-t-1)/(time-4)+tauf(time)*(t-3)/(time-4)
!	end do

    open(unit=1,file='input_transition_guess.txt')
        do t=2,time-1
        read(1,*)r(t),N(t),Tr(t),ghexp(t),tauf(t)
        end do
    close(1)

r1(time)=r(time)
N1(time)=N(time)
r1(1)=r(1)
N1(1)=N(1)
Tr1(1)=Tr(1)
Tr1(time)=Tr(time)	
ghexp1(1)=ghexp(1)
ghexp1(time)=ghexp(time)
tauf1(1)=tauf(1)
tauf1(time)=tauf(time)
pr_g1(:,:,:,1)=pr_g(:,:,:,1)
pr_g1(:,:,:,time)=pr_g(:,:,:,time)

!open(unit=1,file='input_transition_insurance_price_guess.txt')

    do t=2,time-1
    
        !if allowerd to condition on health status, guess insurance price
        if ( condition(t) .eq. 0 ) then
            
        pr_g(ec,1,tc,t)=zero
            
            do hc=1,nh
                if ( tc .lt. jr-1 ) then
                pr_g(ec,1,tc,t)=pr_g(ec,1,tc,t)+psi_t(ec,hc,tc,t)*Nu(ec,hc,tc,t)*cov_p(hc)*sum(pi_h(ec,tc,1:nh,hc)*e_h(1:nh,tc+1))    
                else
                pr_g(ec,1,tc,t)=pr_g(ec,1,tc,t)+psi_t(ec,hc,tc,t)*Nu(ec,hc,tc,t)*cov_p(hc)*(1-cov_m(t+1))*sum(pi_h(ec,tc,1:nh,hc)*e_h(1:nh,tc+1)) 
                end if                    
            end do
                
        pr_g(ec,1,tc,t)=pr_g(ec,1,tc,t)/((1+r(t+1))*sum(Nu(ec,:,tc,t)))
        pr_g(ec,2:nh,tc,t)=pr_g(ec,1,tc,t)
            
        end if
            
            
!         do  tc=1,J
!         read(1,*)pr_g(:,:,tc,t)
!         end do
			
    end do

!close(1)
    
i=0
dtran=1
    
    do while ( i .le. maxit .and. dtran .ge. tol )

        call resid

!     Asdev=abs(K1(2)-K(2))/K(2)
!     Ladev=abs(N1(2)-N(2))/N(2)
!     ghexpdev=abs(ghexp1(2)-ghexp(2))/ghexp(2)
! 	
!         do t=3,time-1
! 
!             if ( abs(K1(t)-K(t))/K(t) .ge. Asdev ) then
!             Asdev=abs(K1(t)-K(t))/K(t)
!             end if
! 				
!             if ( abs(N1(t)-N(t))/N(t) .ge. Ladev ) then
!             Ladev=abs(N1(t)-N(t))/N(t)
!             end if
! 			
!             if ( abs(ghexp1(t)-ghexp(t))/ghexp(t) .ge. ghexpdev ) then
!             ghexpdev=abs(ghexp1(t)-ghexp(t))/ghexp(t)
!             end if
! 			
!         end do

    Asdev=maxval(abs(K1-K))/sum(Nu(:,:,:,1))	
    Ladev=maxval(abs(N1-N))/sum(Nu(:,:,:,1))	        
    ghexpdev=maxval(abs(ghexp1-ghexp))/sum(Nu(:,:,:,1))	
    Trdev=maxval(abs(Tr1-Tr))
    taufdev=maxval(abs(tauf1-tauf))
    insdev=maxval(abs(pr_g-pr_g1))
	
        do t=2,time-1
        r(t)=weight*r(t)+(1-weight)*r1(t)
        N(t)=weight*N(t)+(1-weight)*N1(t)
        Tr(t)=weight*Tr(t)+(1-weight)*Tr1(t)
        ghexp(t)=weight*ghexp(t)+(1-weight)*ghexp1(t)
        tauf(t)=weight*tauf(t)+(1-weight)*tauf1(t)		
        pr_g(:,:,:,t)=weight_p*pr_g(:,:,:,t)+(1-weight_p)*pr_g1(:,:,:,t)           
        end do				

    !note that r(2) is pinned down once N(2) is given
    r(2)=alpha*theta*(N(2)/K(2))**(1.0-alpha) -delta

    ! Check Market Clearing in goods market

        do t=2,time-1
        exdem(t)=C(t)+(1+nn)*K(t+1)-(1-delta)*K(t)+H(t)-Y(t)
        end do

        if ( rank .eq. 0 ) then
        print*,'i, maxloc exdem ',i,maxloc(abs(exdem(2:time-1))),maxval(abs(exdem(2:time-1)))
!        print*,"d1,d2,d3,d4,d5,d6",Asdev/maxval(As),Ladev/maxval(N),Trdev,ghexpdev,taufdev,insdev
        print*,"d1,d2,d3,d4,d5,d6",Asdev,Ladev,Trdev,ghexpdev,taufdev,insdev

            open (unit=1,file='output_transition_aggregates.txt')
            write(1,*)'t C r N K Y Nu w H Tr taul SSnc SSc tauf ex hr Fstmpcnt Gh'
                do t=1,time
                write(1,'(I2,300F12.5)')t,c(t),r(t),N(t),K(t),Y(t),sum(Nu(:,:,:,t)),w(t),H(t),Tr(t),&
                taup(t),SS(1,t),SS(2,t),tauf(t),exdem(t),hour(t),safetycnt(t),ghexp(t)
                end do
            close(1)

            open(unit=1,file='input_transition_guess.txt')
                do t=2,time-1
                write(1,*)r(t),N(t),Tr(t),ghexp(t),tauf(t)
                end do
            close(1)
			
            open(unit=1,file='input_transition_insurance_price_guess.txt')
                do t=2,time-1
                do  tc=1,J
                write(1,*)pr_g(:,:,tc,t)
                end do
                end do
            close(1)
			
        end if

!    dtran=max(Asdev/maxval(As),Ladev/maxval(N),Trdev,ghexpdev,taufdev,insdev)
    dtran=max(Asdev,Ladev,Trdev,ghexpdev,taufdev,insdev)    
    i=i+1
    
    SS_total=zero
    
        do t=1,time
        do ec=1,ne
        SS_total(t)=SS_total(t)+SS(ec,t)*sum(Nu(ec,1:nh,jr:J,t))
        end do
        end do
    
        if ( rank .eq. 0 ) then
            open(unit=1,file='output_transition_insurance_expense.txt')
            write(1,*)'t Pvt Self Emp Mcare Fstamp Mcaid H Fstamptot '
                do t=1,time
                write(1,'(I2,300F12.5)')t,insexptran(t,:),H(t),safety(t)
                end do
            close(1)

            open ( unit=1, file='output_transition_insurance_headcount.txt')
            write(1,*)'t Pvt Self Emp Mcare Fstamp Mcaid '
                do t=1,time
                write(1,'(I2,300F12.5)')t,pvtinsured(t), selfinsured(t), employer(t), medicare(t), foodstamp(t), medicaid(t)
                end do
            close(1)

            open ( unit=1, file='output_transition_social_security.txt')
            write(1,*)'t SS'
                do t=1,time
                write(1,'(I2,300F12.5)')t,SS_total(t)
                end do
            close(1)
            
        end if

        !compute voting outcome
!        call voting
 
        !compute welfare measures
        call welfare

    end do

    if ( dtran .ge. tol .and. rank .eq. 0 ) then
    print*,'transition not converged '
    end if

    if ( rank .eq. 0 ) then
    print*,'transition converged '
    end if


end subroutine transition
