! This subroutine computes the Coefficient of Variation in Wealth 
! and Labor Income in the intial steady state

subroutine variance (cvl, cvw)

use params
implicit none
double precision, intent(out) :: cvl, cvw
double precision :: alinc, varlinc, ma, varweal
double precision,dimension(na) :: kr1

! Average After Tax Labor Income
alinc=0

    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do ac=1,na
    do tc=1,J

        if ( tc .lt. jr ) then
        alinc=alinc+wss*ep(ec,tc)*eta(ec,sc)*z_h(hc)*&
        lfunss(gc,ec,hc,sc,ac,tc)*Nuss(ec,hc,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)/sum(Nuss)
        else if ( tc .ge. jr ) then
        alinc=alinc+ssss(ec)*Nuss(ec,hc,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)/sum(Nuss)
        end if

    end do
    end do
    end do	
    end do
    end do
    end do

! Variance of After Tax Labor Income 
varlinc=0
		
    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do ac=1,na
    do tc=1,J
		
        if ( tc .lt. jr ) then
        varlinc=varlinc+((alinc-wss*ep(ec,tc)*eta(ec,sc)*z_h(hc)*&
        lfunss(gc,ec,hc,sc,ac,tc))**2)*Nuss(ec,hc,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)/sum(Nuss)
        else if ( tc .ge. jr ) then
        varlinc=varlinc+((alinc-ssss(ec))**2)*Nuss(ec,hc,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)/sum(Nuss)
        end if
			
    end do
    end do
    end do
    end do
    end do
    end do

! Coefficient of Variation of After Tax labor Income (standard deviation over mean)
    cvl=(varlinc**0.5)/alinc

! Average Asset Holdings
ma=sum(ADisss(1:na)*grida(1:na))+Trss

    do ac=1,na
    kr1(ac)=(grida(ac)+Trss-ma)**2
    end do

! Variance of Asset Holdings
varweal=sum(ADisss(1:na)*kr1(1:na))

! Coefficient of Variation of Asset Holdings
    cvw=(varweal**0.5)/ma

end subroutine variance