subroutine welfare

use params
use mini
implicit none
include 'mpif.h'
!Variables for welfare comparison

double precision, dimension(ng,ne,nh,ns,na,J+1) :: V1w, V2w, Vtimew
double precision, dimension(ng,ne,nh,ns,na,J):: equivar, equivarc, equivarc1, WEV

double precision :: avg_g, avg_g_w, avg_g_l
double precision :: avg_c, avg_c_w, avg_c_l
double precision :: avg_c1, avg_c1_w, avg_c1_l
double precision :: avg_w, avg_w_w, avg_w_l

double precision :: welfbyedu(ne), welfbyhealth(nh), welfbyage(J), welfbyagecheck(J), welfbyassets(5), welfbylabearnings(5), welfbyins(6)
double precision :: cwelfbyedu(ne), cwelfbyhealth(nh), cwelfbyage(J), cwelfbyagecheck(J), cwelfbyassets(5), cwelfbylabearnings(5), cwelfbyins(6)
double precision :: c1welfbyedu(ne), c1welfbyhealth(nh), c1welfbyage(J), c1welfbyagecheck(J), c1welfbyassets(5), c1welfbylabearnings(5), c1welfbyins(6)
double precision :: wwelfbyedu(ne), wwelfbyhealth(nh), wwelfbyage(J), wwelfbyagecheck(J), wwelfbyassets(5), wwelfbylabearnings(5), wwelfbyins(6)

double precision :: temp1, temp2
double precision :: equiss, equitr
double precision :: cequiss, cequitr, cequi(time)

integer :: iq, in
double precision :: temp_iq(5,2), temp_in(6)

double precision :: votetotal
double precision :: votebyedu(ne), votebyhealth(nh), votebyage(J), votebyassets(5), votebylabearnings(5), votebyins(6)
double precision :: votebyagehealth(J,nh)
double precision :: medicaidbyedu(ne,2), medicaidbyhealth(nh,2), medicaidbyage(J,2), agebyassets(5), agebylabearnings(5)
double precision :: fstampbyedu(ne,2), fstampbyhealth(nh,2), fstampbyage(J,2)

double precision :: num, den

integer :: cnt_decrease
integer(kind=1), dimension(ng,ne,nh,ns,J) :: check_decrease

!for WEV
double precision :: WEV_min, WEV_max, Vtemp
double precision, dimension(2) :: vals
integer, dimension(2) :: inds
double precision :: min_bound, max_bound

integer :: iter_bi
integer, parameter :: itmax_bi=1000
double precision, parameter :: tol_bi=1e-6
double precision :: d_bi

!for mpi
integer, parameter :: ni_wf=ng*ne*nh*ns*na*J
integer :: zmap_wf(ni_wf,6), id_wf, np_wf, itop_wf, iend_wf
double precision, allocatable :: WEVmpi(:)
double precision, allocatable :: WEVrecmpi(:)
!gridsearch
integer :: ja
integer :: find

!choose foodstamp g_dfss1=0


V1w=V1
V2w=V2
Vtimew=Vtime

    if ( rank .eq. 0 ) then
    
    open(unit=1,file='fornow.txt')
        do tc=1,J
        do gc=1,ng
        do ec=1,ne
        do hc=1,nh
        do sc=1,ns
        do ac=1,na
        write(1,*)V1w(gc,ec,hc,sc,ac,tc),V2w(gc,ec,hc,sc,ac,tc),Phissadjusted1(gc,ec,hc,sc,ac,tc),g_dfss1(gc,ec,hc,sc,ac,tc)
        end do
        end do
        end do
        end do
        end do
        end do
    close(1)
    
    end if

!Tr(2)=.03   
!     open(unit=1,file='fornow.txt')
!         do tc=1,J
!         do gc=1,ng
!         do ec=1,ne
!         do hc=1,nh
!         do sc=1,ns
!         do ac=1,na
!         read(1,*)V1w(gc,ec,hc,sc,ac,tc),V2w(gc,ec,hc,sc,ac,tc),Phissadjusted1(gc,ec,hc,sc,ac,tc),g_dfss1(gc,ec,hc,sc,ac,tc)
!         end do
!         end do
!         end do
!         end do
!         end do
!         end do
!     close(1)    
            
    cnt_decrease=0
    check_decrease=0
    
    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do tc=1,J      
    
        do ac=2,na                            
                                        
            if ( V1w(gc,ec,hc,sc,ac,tc) .le. V1w(gc,ec,hc,sc,ac-1,tc) ) then
            check_decrease(gc,ec,hc,sc,tc)=1
            end if                        
                                                                    
        end do
    
        if ( check_decrease(gc,ec,hc,sc,tc) .eq. 1 ) then            
        cnt_decrease=cnt_decrease+1		
        end if
        
    end do
    end do
    end do
    end do
    end do    
            
    if ( rank .eq. 0 ) then
    print*,'cnt_decrease, ng*ne*nh*ns*J',cnt_decrease,ng*ne*nh*ns*J
    end if  

!parallelizing to solve for WEV

! gridpoints per processor
np_wf=(ni_wf-1)/nproc+1
itop_wf=rank*np_wf+1
iend_wf=MIN((rank+1)*np_wf,ni_wf)

id_wf=0

    do tc=1,J
    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do ac=1,na
    id_wf=id_wf+1
    zmap_wf(id_wf,1)=tc    
    zmap_wf(id_wf,2)=gc
    zmap_wf(id_wf,3)=ec
    zmap_wf(id_wf,4)=hc
    zmap_wf(id_wf,5)=sc
    zmap_wf(id_wf,6)=ac
    end do
    end do
    end do
    end do
    end do
    end do
        
WEV=zero    

    allocate (WEVmpi(np_wf))
    allocate (WEVrecmpi(np_wf*nproc))
    
    do id_wf=itop_wf,iend_wf

    tc=zmap_wf(id_wf,1)    
    gc=zmap_wf(id_wf,2)
    ec=zmap_wf(id_wf,3)
    hc=zmap_wf(id_wf,4)
    sc=zmap_wf(id_wf,5)
    ac=zmap_wf(id_wf,6)
 
    !V2w(gc,ec,hc,sc,ac,tc) is given
    !Want V1w(gc,ec,hc,sc,ac+WEV,tc)=V1w(gc,ec,hc,sc,ac,tc) where ac+Tr+WEV >= 0
  
        if ( Phissadjusted1(gc,ec,hc,sc,ac,tc) .gt. zero .and. check_decrease(gc,ec,hc,sc,tc) .eq. 0 ) then       
           
        WEV_min=-grida(ac)-Tr(2)
            call onedlin (grida,V1w(gc,ec,hc,sc,:,tc),na,grida(ac)+WEV_min,Vtemp)
                        
            if ( Vtemp-V2w(gc,ec,hc,sc,ac,tc) .gt. zero ) then
                
            WEVmpi(id_wf-itop_wf+1)=WEV_min
                
            else
                                
            WEV_max=grida(na)-grida(ac)
                call onedlin (grida,V1w(gc,ec,hc,sc,:,tc),na,grida(ac)+WEV_max,Vtemp)
            
                if ( Vtemp-V2w(gc,ec,hc,sc,ac,tc) .lt. zero ) then
                    
                WEVmpi(id_wf-itop_wf+1)=WEV_max
            
                else
                    
                !bisection
                iter_bi=0
                d_bi=1
                
                    do while ( iter_bi .le. itmax_bi .and. abs(d_bi) .ge. tol_bi )
                               
                    WEVmpi(id_wf-itop_wf+1)=(WEV_min+WEV_max)/2.
                        call onedlin (grida,V1w(gc,ec,hc,sc,:,tc),na,grida(ac)+WEVmpi(id_wf-itop_wf+1),Vtemp)
                    
                    d_bi=Vtemp-V2w(gc,ec,hc,sc,ac,tc)
                    
                        if ( d_bi .le. zero ) then
                        WEV_min=WEVmpi(id_wf-itop_wf+1)
                        else if ( d_bi .gt. zero ) then
                        WEV_max=WEVmpi(id_wf-itop_wf+1)
                        end if
                        
                    iter_bi=iter_bi+1
                    
                    end do
                    
                    if ( abs(d_bi) .ge. tol_bi ) then
                    print*,'bisection did not converge welfare.f90 ',abs(d_bi)
                        call exit
                    end if
                    
                end if
                    
            end if
     
        else if ( Phissadjusted1(gc,ec,hc,sc,ac,tc) .gt. zero .and. check_decrease(gc,ec,hc,sc,tc) .eq. 1 ) then  

        find=0
        
            call onedlin (grida,V1w(gc,ec,hc,sc,:,tc),na,-tr(2),Vtemp)
            
            if ( Vtemp-V2w(gc,ec,hc,sc,ac,tc) .gt. zero ) then
            find=1
            WEVmpi(id_wf-itop_wf+1)=-tr(2)-grida(ac)            
            end if
            
        ja=1
        
            do while ( ja .le. na .and. find .eq. 0 )
                            
                call onedlin (grida,V1w(gc,ec,hc,sc,:,tc),na,grida(ja),Vtemp)
                
                if ( Vtemp .gt. V2w(gc,ec,hc,sc,ac,tc) ) then
                WEVmpi(id_wf-itop_wf+1)=grida(ja)-grida(ac)
                find=1
                end if
            
            ja=ja+1

            end do
            
            if ( find .eq. 0 ) then
            print*,'problem welfare.f90'
                call exit
            end if
            
        else
        
        WEVmpi(id_wf-itop_wf+1)=zero
        
        end if
        
    end do
    
    call MPI_ALLGATHER (WEVmpi,np_wf,mpi_double_precision,WEVrecmpi,np_wf,mpi_double_precision,mpi_comm_world,ierr)

    id_wf=0
    min_bound=zero
    max_bound=zero
    
    do tc=1,J
    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do ac=1,na
    
    id_wf=id_wf+1
    WEV(gc,ec,hc,sc,ac,tc)=WEVrecmpi(id_wf)
        
        if ( WEVrecmpi(id_wf) .eq. -grida(ac)-Tr(2) ) then        
        min_bound=min_bound+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)/sum(Nu(:,:,:,2))        
        end if

        if ( WEVrecmpi(id_wf) .eq. grida(na)-grida(ac) ) then
        max_bound=max_bound+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)/sum(Nu(:,:,:,2))
        end if      
                        
    end do
    end do
    end do
    end do
    end do
    end do
    
    deallocate (WEVmpi,WEVrecmpi)


  
avg_g=zero
avg_g_w=zero
avg_g_l=zero

avg_c=zero
avg_c_w=zero
avg_c_l=zero

avg_c1=zero
avg_c1_w=zero
avg_c1_l=zero

avg_w=zero
avg_w_w=zero
avg_w_l=zero

temp1=zero
temp2=zero

    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do ac=1,na
    do tc=1,J      
    
    equivar(gc,ec,hc,sc,ac,tc)=( V2w(gc,ec,hc,sc,ac,tc)/V1w(gc,ec,hc,sc,ac,tc) )**(1.0/ ( (1.0-sigma) ) ) - 1
    equivarc(gc,ec,hc,sc,ac,tc)=( V2w(gc,ec,hc,sc,ac,tc)/V1w(gc,ec,hc,sc,ac,tc) )**(1.0/ ( gamma*(1.0-sigma) ) ) - 1
    
    num=((V2w(gc,ec,hc,sc,ac,tc)-(V1w(gc,ec,hc,sc,ac,tc)-U(cfunss1(gc,ec,hc,sc,ac,tc),lfunss1(gc,ec,hc,sc,ac,tc),zero)))*(1-sigma))**(1./(1.-sigma))
    den=(cfunss1(gc,ec,hc,sc,ac,tc)**gamma)*((1-lfunss1(gc,ec,hc,sc,ac,tc))**(1-gamma))    
    equivarc1(gc,ec,hc,sc,ac,tc)=((num/den)**(1./gamma)-1)*cfunss1(gc,ec,hc,sc,ac,tc)
    
    avg_g=avg_g+equivar(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)/sum(Nu(:,:,:,2))
    avg_c=avg_c+equivarc(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)/sum(Nu(:,:,:,2))
    avg_c1=avg_c1+equivarc1(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)/sum(Nu(:,:,:,2))
    avg_w=avg_w+WEV(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)/sum(Nu(:,:,:,2))
    
        if ( V2w(gc,ec,hc,sc,ac,tc) .ge. V1w(gc,ec,hc,sc,ac,tc) ) then
        avg_g_w=avg_g_w+equivar(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)
        avg_c_w=avg_c_w+equivarc(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)        
        avg_c1_w=avg_c1_w+equivarc1(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)                
        avg_w_w=avg_w_w+WEV(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)                
        temp1=temp1+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)
        end if
        
        if ( V2w(gc,ec,hc,sc,ac,tc) .lt. V1w(gc,ec,hc,sc,ac,tc) ) then
        avg_g_l=avg_g_l+equivar(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)
        avg_c_l=avg_c_l+equivarc(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)        
        avg_c1_l=avg_c1_l+equivarc1(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)                
        avg_w_l=avg_w_l+WEV(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)                        
        temp2=temp2+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,2)
        end if
                                            
        if ( isnan(V1w(gc,ec,hc,sc,ac,tc)) .and. rank .eq. 0 ) then
        print*,'isnan num 1 at welfare.f90',V1w(gc,ec,hc,sc,ac,tc)
        print*,gc,ec,hc,sc,ac,tc
            call exit
        end if

        if ( isnan(V2w(gc,ec,hc,sc,ac,tc)) .and. rank .eq. 0) then
        print*,'isnan num 2 welfare.f90',V2w(gc,ec,hc,sc,ac,tc)
        print*,gc,ec,hc,sc,ac,tc
            call exit
        end if                                             
                                                                    
    end do        
    end do
    end do
    end do
    end do
    end do
    
avg_g_w=avg_g_w/temp1
avg_c_w=avg_c_w/temp1
avg_c1_w=avg_c1_w/temp1
avg_w_w=avg_w_w/temp1

avg_g_l=avg_g_l/temp2
avg_c_l=avg_c_l/temp2
avg_c1_l=avg_c1_l/temp2
avg_w_l=avg_w_l/temp2

votetotal=temp1/sum(Nu(:,:,:,2))

!welfare by education
!welfare by health
!welfare by age

welfbyedu=zero
welfbyhealth=zero
welfbyage=zero
welfbyagecheck=zero
welfbyassets=zero
welfbylabearnings=zero
welfbyins=zero

    cwelfbyedu=zero
    cwelfbyhealth=zero
    cwelfbyage=zero
    cwelfbyagecheck=zero
    cwelfbyassets=zero
    cwelfbylabearnings=zero
    cwelfbyins=zero

    c1welfbyedu=zero
    c1welfbyhealth=zero
    c1welfbyage=zero
    c1welfbyagecheck=zero
    c1welfbyassets=zero
    c1welfbylabearnings=zero
    c1welfbyins=zero
    
    wwelfbyedu=zero
    wwelfbyhealth=zero
    wwelfbyage=zero
    wwelfbyagecheck=zero
    wwelfbyassets=zero
    wwelfbylabearnings=zero
    wwelfbyins=zero
    
votebyedu=zero
votebyhealth=zero
votebyage=zero
votebyassets=zero
votebylabearnings=zero
votebyins=zero
votebyagehealth=zero

temp_iq=zero
temp_in=zero

medicaidbyedu=zero
medicaidbyhealth=zero
medicaidbyage=zero

fstampbyedu=zero
fstampbyhealth=zero
fstampbyage=zero

agebyassets=zero
agebylabearnings=zero
 
    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    do gc=1,ng
    do sc=1,ns
    do ac=1,na
    
    welfbyedu(ec)=welfbyedu(ec)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivar(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(ec,:,:,1))
    welfbyhealth(hc)=welfbyhealth(hc)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivar(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(:,hc,:,1))
    welfbyage(tc)=welfbyage(tc)+(Phissage1(gc,ec,hc,sc,ac,tc)*equivar(gc,ec,hc,sc,ac,tc))
    welfbyagecheck(tc)=welfbyagecheck(tc)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivar(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(:,:,tc,1))    
    
    cwelfbyedu(ec)=cwelfbyedu(ec)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(ec,:,:,1))
    cwelfbyhealth(hc)=cwelfbyhealth(hc)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(:,hc,:,1))
    cwelfbyage(tc)=cwelfbyage(tc)+(Phissage1(gc,ec,hc,sc,ac,tc)*equivarc(gc,ec,hc,sc,ac,tc))
    cwelfbyagecheck(tc)=cwelfbyagecheck(tc)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(:,:,tc,1))       

    c1welfbyedu(ec)=c1welfbyedu(ec)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc1(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(ec,:,:,1))
    c1welfbyhealth(hc)=c1welfbyhealth(hc)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc1(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(:,hc,:,1))
    c1welfbyage(tc)=c1welfbyage(tc)+(Phissage1(gc,ec,hc,sc,ac,tc)*equivarc1(gc,ec,hc,sc,ac,tc))
    c1welfbyagecheck(tc)=c1welfbyagecheck(tc)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc1(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(:,:,tc,1))       
    
    wwelfbyedu(ec)=wwelfbyedu(ec)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*WEV(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(ec,:,:,1))
    wwelfbyhealth(hc)=wwelfbyhealth(hc)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*WEV(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(:,hc,:,1))
    wwelfbyage(tc)=wwelfbyage(tc)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*WEV(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)/sum(Nu(:,:,tc,1))   
    wwelfbyagecheck(tc)=wwelfbyagecheck(tc)+(Phissage1(gc,ec,hc,sc,ac,tc)*WEV(gc,ec,hc,sc,ac,tc)) 
    
    medicaidbyedu(ec,1)=medicaidbyedu(ec,1)+g_dmss1(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(ec,:,:,1))
    medicaidbyhealth(hc,1)=medicaidbyhealth(hc,1)+g_dmss1(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(:,hc,:,1))
    medicaidbyage(tc,1)=medicaidbyage(tc,1)+g_dmss1(gc,ec,hc,sc,ac,tc)*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(:,:,tc,1))

    fstampbyedu(ec,1)=fstampbyedu(ec,1)+(1-g_dfss1(gc,ec,hc,sc,ac,tc))*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(ec,:,:,1))
    fstampbyhealth(hc,1)=fstampbyhealth(hc,1)+(1-g_dfss1(gc,ec,hc,sc,ac,tc))*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(:,hc,:,1))
    fstampbyage(tc,1)=fstampbyage(tc,1)+(1-g_dfss1(gc,ec,hc,sc,ac,tc))*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(:,:,tc,1))
    
    medicaidbyedu(ec,2)=medicaidbyedu(ec,2)+g_dmss3(gc,ec,hc,sc,ac,tc)*PhiDadjusted3(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,3)/sum(Nu(ec,:,:,3))
    medicaidbyhealth(hc,2)=medicaidbyhealth(hc,2)+g_dmss3(gc,ec,hc,sc,ac,tc)*PhiDadjusted3(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,3)/sum(Nu(:,hc,:,3))
    medicaidbyage(tc,2)=medicaidbyage(tc,2)+g_dmss3(gc,ec,hc,sc,ac,tc)*PhiDadjusted3(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,3)/sum(Nu(:,:,tc,3))

    fstampbyedu(ec,2)=fstampbyedu(ec,2)+(1-g_dfss3(gc,ec,hc,sc,ac,tc))*PhiDadjusted3(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,3)/sum(Nu(ec,:,:,3))
    fstampbyhealth(hc,2)=fstampbyhealth(hc,2)+(1-g_dfss3(gc,ec,hc,sc,ac,tc))*PhiDadjusted3(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,3)/sum(Nu(:,hc,:,3))
    fstampbyage(tc,2)=fstampbyage(tc,2)+(1-g_dfss3(gc,ec,hc,sc,ac,tc))*PhiDadjusted3(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,3)/sum(Nu(:,:,tc,3))
    
    
        if ( V2w(gc,ec,hc,sc,ac,tc) .ge. V1w(gc,ec,hc,sc,ac,tc) ) then    
        votebyedu(ec)=votebyedu(ec)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(ec,:,:,1))
        votebyhealth(hc)=votebyhealth(hc)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(:,hc,:,1))
        votebyage(tc)=votebyage(tc)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(:,:,tc,1))   
        votebyagehealth(tc,hc)=votebyagehealth(tc,hc)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)/sum(Nu(:,hc,tc,1))
        end if
        
        do iq=1,5
        
            if ( quintassetdist(gc,ec,hc,sc,ac,tc) .eq. iq ) then
            welfbyassets(iq)=welfbyassets(iq)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivar(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)
            cwelfbyassets(iq)=cwelfbyassets(iq)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)
            c1welfbyassets(iq)=c1welfbyassets(iq)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc1(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)            
            wwelfbyassets(iq)=wwelfbyassets(iq)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*WEV(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)
            temp_iq(iq,1)=temp_iq(iq,1)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)

                if ( V2w(gc,ec,hc,sc,ac,tc) .ge. V1w(gc,ec,hc,sc,ac,tc) ) then    
                votebyassets(iq)=votebyassets(iq)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)
                end if

            agebyassets(iq)=agebyassets(iq)+tc*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)
                
            end if
            
            if ( quintlabearningsdist(gc,ec,hc,sc,ac,tc) .eq. iq ) then
            welfbylabearnings(iq)=welfbylabearnings(iq)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivar(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)
            cwelfbylabearnings(iq)=cwelfbylabearnings(iq)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)
            c1welfbylabearnings(iq)=c1welfbylabearnings(iq)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc1(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)            
            wwelfbylabearnings(iq)=wwelfbylabearnings(iq)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*WEV(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)
            temp_iq(iq,2)=temp_iq(iq,2)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)
            
                if ( V2w(gc,ec,hc,sc,ac,tc) .ge. V1w(gc,ec,hc,sc,ac,tc) ) then    
                votebylabearnings(iq)=votebylabearnings(iq)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)
                end if

            agebylabearnings(iq)=agebylabearnings(iq)+tc*Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)
                
            end if
            
        end do
    
        do in=1,6
        
            if ( hifunss1(gc,ec,hc,sc,ac,tc) .eq. in ) then
            
            welfbyins(in)=welfbyins(in)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivar(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)
            cwelfbyins(in)=cwelfbyins(in)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)
            c1welfbyins(in)=c1welfbyins(in)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*equivarc1(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)            
            wwelfbyins(in)=wwelfbyins(in)+(Phissadjusted1(gc,ec,hc,sc,ac,tc)*WEV(gc,ec,hc,sc,ac,tc))*Nu(ec,hc,tc,1)
            
            temp_in(in)=temp_in(in)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)
            
                if ( V2w(gc,ec,hc,sc,ac,tc) .ge. V1w(gc,ec,hc,sc,ac,tc) ) then    
                votebyins(in)=votebyins(in)+Phissadjusted1(gc,ec,hc,sc,ac,tc)*Nu(ec,hc,tc,1)
                end if

            end if
            
        end do
       
    end do
    end do
    end do
    end do
    end do
    end do

    do iq=1,5
    welfbyassets(iq)=welfbyassets(iq)/temp_iq(iq,1)
    cwelfbyassets(iq)=cwelfbyassets(iq)/temp_iq(iq,1)
    c1welfbyassets(iq)=c1welfbyassets(iq)/temp_iq(iq,1)    
    wwelfbyassets(iq)=wwelfbyassets(iq)/temp_iq(iq,1)        
    votebyassets(iq)=votebyassets(iq)/temp_iq(iq,1)
    agebyassets(iq)=agebyassets(iq)/temp_iq(iq,1)   
    welfbylabearnings(iq)=welfbylabearnings(iq)/temp_iq(iq,2)    
    cwelfbylabearnings(iq)=cwelfbylabearnings(iq)/temp_iq(iq,2)
    c1welfbylabearnings(iq)=c1welfbylabearnings(iq)/temp_iq(iq,2)    
    wwelfbylabearnings(iq)=wwelfbylabearnings(iq)/temp_iq(iq,2)        
    votebylabearnings(iq)=votebylabearnings(iq)/temp_iq(iq,2)
    agebylabearnings(iq)=agebylabearnings(iq)/temp_iq(iq,2)
    end do
    
    do in=1,6
    welfbyins(in)=welfbyins(in)/temp_in(in)
    cwelfbyins(in)=cwelfbyins(in)/temp_in(in)
    c1welfbyins(in)=c1welfbyins(in)/temp_in(in)    
    wwelfbyins(in)=wwelfbyins(in)/temp_in(in)    
    votebyins(in)=votebyins(in)/temp_in(in)            
    end do
    
temp1=0
temp2=0

    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    temp1=temp1+put_h(ec,1,hc)*put(ec,sc)*put_e(ec)*put_g(gc)*vtimew(gc,ec,hc,sc,1,1)
    temp2=temp2+put_h(ec,1,hc)*put(ec,sc)*put_e(ec)*put_g(gc)*v1w(gc,ec,hc,sc,1,1)
    end do
    end do
    end do
    end do

equiss=(temp1/temp2)**(1.0/(1-sigma))-1
    cequiss=(temp1/temp2)**(1.0/ (gamma*(1-sigma)) )-1

temp1=0
temp2=0

    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    temp1=temp1+put_h(ec,1,hc)*put(ec,sc)*put_e(ec)*put_g(gc)*v2w(gc,ec,hc,sc,1,1)
    temp2=temp2+put_h(ec,1,hc)*put(ec,sc)*put_e(ec)*put_g(gc)*v1w(gc,ec,hc,sc,1,1)
    end do
    end do
    end do
    end do

equitr=(temp1/temp2)**(1.0/(1-sigma))-1
    cequitr=(temp1/temp2)**(1.0/ ( gamma*(1-sigma) ))-1                                
        
    cequi=zero

    do date=1,time
    
    temp1=0
    temp2=0

        do gc=1,ng
        do ec=1,ne
        do hc=1,nh
        do sc=1,ns
        temp1=temp1+put_h(ec,1,hc)*put(ec,sc)*put_e(ec)*put_g(gc)*vborn(gc,ec,hc,sc,date)
        temp2=temp2+put_h(ec,1,hc)*put(ec,sc)*put_e(ec)*put_g(gc)*v1w(gc,ec,hc,sc,1,1)
        end do
        end do
        end do
        end do
         
    cequi(date)=(temp1/temp2)**(1.0/ ( gamma*(1-sigma) ))-1  
         
    end do
    
    if ( rank .eq. 0 ) then
    
        open (unit=1,file='output_welfare_and_voting1.txt')
        write(1,*)'ss_comparison'
        write(1,'(300F12.5)')equiss,cequiss
        write(1,*)'transition_comparison'
        write(1,'(300F12.5)')equitr,cequitr
        write(1,*)'avg_g'
        write(1,'(300F12.5)')avg_g,avg_c,avg_c1,avg_w,votetotal
        write(1,*)'avg_g_w'
        write(1,'(300F12.5)')avg_g_w,avg_c_w,avg_c1_w,avg_w_w
        write(1,*)'avg_g_l'
        write(1,'(300F12.5)')avg_g_l,avg_c_l,avg_c1_l,avg_w_l
        write(1,*)'y_2010'
        write(1,'(300F12.5)')y_2010
        write(1,*)'min_bound, max_bound '
        write(1,'(300F12.5)')min_bound,max_bound   
        write(1,*)'time wf_of_unborns'
            do date=1,time
            write(1,'(I2,300F12.5)')date,cequi(date)
            end do            
        close(1)

        open (unit=1,file='output_welfare_and_voting2.txt')
        write(1,*)'var c_l_wf c_wf c1_wf w_wf vote mcaid1/age mcaid3 fstmp1 fstmp3 vh1 vh2 vh3'
            do tc=1,j
            write(1,'(I2,300F12.5)')tc+19,welfbyage(tc),cwelfbyage(tc),c1welfbyage(tc),wwelfbyage(tc),votebyage(tc),medicaidbyage(tc,:),fstampbyage(tc,:),votebyagehealth(tc,:)
            end do
            do ec=1,ne
            write(1,'(I2,300F12.5)')ec,welfbyedu(ec),cwelfbyedu(ec),c1welfbyedu(ec),wwelfbyedu(ec),votebyedu(ec),medicaidbyedu(ec,:),fstampbyedu(ec,:)
            end do
            do hc=1,nh
            write(1,'(I2,300F12.5)')hc,welfbyhealth(hc),cwelfbyhealth(hc),c1welfbyhealth(hc),wwelfbyhealth(hc),votebyhealth(hc),medicaidbyhealth(hc,:),fstampbyhealth(hc,:)
            end do
            do iq=1,5
            write(1,'(I2,300F12.5)')iq,welfbyassets(iq),cwelfbyassets(iq),c1welfbyassets(iq),wwelfbyassets(iq),votebyassets(iq),agebyassets(iq)+19
            write(6,'(300F12.5)')temp_iq(iq,1)
            end do
            do iq=1,5
            write(1,'(I2,300F12.5)')iq,welfbylabearnings(iq),cwelfbylabearnings(iq),c1welfbylabearnings(iq),wwelfbylabearnings(iq),votebylabearnings(iq),agebylabearnings(iq)+19
            write(6,'(300F12.5)')temp_iq(iq,2)
            end do                                    
            do in=1,6
            write(1,'(I2,300F12.5)')in,welfbyins(in),cwelfbyins(in),c1welfbyins(in),wwelfbyins(in),votebyins(in)
            end do            
        close(1)



        
    end if
		
end subroutine welfare 